C     This version of the Fortran 66 character primitives
C     contains code for big-endian addressing (IBM 360, Motorola
C     68xxx, NS 32xxx, Sun SPARC, ...) and little-ending
C     addressing (Intel 80xxx and DEC VAX).  It must be first
C     processed by the C preprocessor, with BIGENDIAN defined or
C     not, to select the correct version.

      INTEGER FUNCTION  KARASC (CHAR)
      INTEGER CHAR

#ifdef BIGENDIAN
      KARASC = AND(RSHIFT(CHAR,24),255)
#else
      KARASC = AND(CHAR,255)
#endif

      IF (KARASC .GT. 127) KARASC = -1
      RETURN
      END


      INTEGER FUNCTION  KARCHR (ORD)
      INTEGER MASK
      CHARACTER*1 CHAR(4),ORD(4)
      EQUIVALENCE (MASK,CHAR(1))
C     DATA MASK/'    '/
      DATA MASK/4H    /

#ifdef BIGENDIAN
      CHAR(1) = ORD(4)
#else
      CHAR(1) = ORD(1)
#endif

      KARCHR = MASK
      RETURN
      END


      INTEGER FUNCTION  KARCM2 (TEXTA,LOCA,TEXTB,LOCB,LENGTH)
C     (COMPARE CHARACTERS IGNORING CASE)
C     GIVEN TWO PACKED CHARACTER STRINGS IN TEXTA(*) AND TEXTB(*),
C     COMPARE "LENGTH" CHARACTERS BEGINNING AT OFFSETS "LOCA"
C     AND "LOCB" RESPECTIVELY.  RETURN -1, 0, OR +1 FOR A .LT. B,
C     A .EQ. B, AND A .GT. B, RESPECTIVELY, WHERE THE COMPARISONS
C     ARE DONE USING THE ASCII COLLATING SEQUENCE.  IF ANY OF
C     "LOCA", "LOCB", OR "LENGTH" ARE LESS THAN 1, KARCMP=0 IS
C     RETURNED.  UPPER- AND LOWER-CASE LETTERS ARE TREATED AS
C     EQUIVALENT.
C     (06-DEC-79)
      INTEGER          CHARA,       CHARB,       IARG,        KARASC
      INTEGER          LENGTH,      LOCA,        LOCB,        OFFSET
      INTEGER          TEXTA(*),    TEXTB(*)
      LOGICAL          LOWER
      LOWER(IARG) = (97 .LE. IARG) .AND. (IARG .LE. 122)
      KARCM2 = 0
      IF (LOCA .LE. 0) GO TO 60
      IF (LOCB .LE. 0) GO TO 60
      OFFSET = 0
      GO TO 50
C
C     DO WHILE (OFFSET .LT. LENGTH) -- PUT TEST AT END TO SAVE GO TO.
C
   10 CALL KARGET (CHARA,TEXTA,OFFSET+LOCA)
      CALL KARGET (CHARB,TEXTB,OFFSET+LOCB)
      CHARA = KARASC(CHARA)
      CHARB = KARASC(CHARB)
      IF (LOWER(CHARA)) CHARA = CHARA - 32
      IF (LOWER(CHARB)) CHARB = CHARB - 32
      IF (CHARA - CHARB) 20,40,30
   20 KARCM2 = -1
      GO TO 60
   30 KARCM2 = +1
      GO TO 60
   40 OFFSET = OFFSET + 1
   50 IF (OFFSET .LT. LENGTH) GO TO 10
C
C     END WHILE
C
   60 RETURN
      END


      INTEGER FUNCTION  KARCMP (TEXTA,LOCA,TEXTB,LOCB,LENGTH)
C     (COMPARE CHARACTERS)
C     GIVEN TWO PACKED CHARACTER STRINGS IN TEXTA(*) AND TEXTB(*),
C     COMPARE "LENGTH" CHARACTERS BEGINNING AT OFFSETS "LOCA"
C     AND "LOCB" RESPECTIVELY.  RETURN -1, 0, OR +1 FOR A .LT. B,
C     A .EQ. B, AND A .GT. B, RESPECTIVELY, WHERE THE COMPARISONS
C     ARE DONE USING THE ASCII COLLATING SEQUENCE.  IF ANY OF
C     "LOCA", "LOCB", OR "LENGTH" ARE LESS THAN 1, KARCMP=0 IS
C     RETURNED.
C     (06-DEC-79)
      INTEGER          CHARA,       CHARB,       KARASC,      LENGTH
      INTEGER          LOCA,        LOCB,        OFFSET,      TEXTA(*)
      INTEGER          TEXTB(*)
      KARCMP = 0
      IF (LOCA .LE. 0) GO TO 60
      IF (LOCB .LE. 0) GO TO 60
      OFFSET = 0
      GO TO 50
C
C     DO WHILE (OFFSET .LT. LENGTH) -- PUT TEST AT END TO SAVE GO TO.
C
   10 CALL KARGET (CHARA,TEXTA,OFFSET+LOCA)
      CALL KARGET (CHARB,TEXTB,OFFSET+LOCB)
      CHARA = KARASC(CHARA)
      CHARB = KARASC(CHARB)
      IF (CHARA - CHARB) 20,40,30
   20 KARCMP = -1
      GO TO 60
   30 KARCMP = +1
      GO TO 60
   40 OFFSET = OFFSET + 1
   50 IF (OFFSET .LT. LENGTH) GO TO 10
C
C     END WHILE
C
   60 RETURN
      END


      SUBROUTINE  KARGET (CH,STRING,NPOS)
      INTEGER NPOS
      CHARACTER*1 STRING(NPOS)
      INTEGER CH, UNSPEC

#ifdef BIGENDIAN
      DATA UNSPEC /Z'00202020'/
      IF (NPOS .GT. 0) THEN
           CH = OR(UNSPEC,LSHIFT(ICHAR(STRING(NPOS)),24))
      ELSE
           CH = 0
      END IF
#else
      DATA UNSPEC /Z'20202000'/
      IF (NPOS .GT. 0) THEN
           CH = OR(UNSPEC,ICHAR(STRING(NPOS)))
      ELSE
           CH = 0
      END IF
#endif

      RETURN
      END


      INTEGER FUNCTION  KARID2 (TEXTA,LOCA,LENA,TEXTB,LOCB,LENB)
C     (Substring Index Ignoring Case)
C     Given two packed character strings defined by the arguments
C     TEXTA,LOCA,LENA  and  TEXTB,LOCB,LENB,  search  the   first
C     string for the first occurrence  of the second string.   If
C     any of the arguments LOCA, LENA, LOCB, or LENB are invalid,
C     or if the second string is  not found in the first,  return
C     0.  Otherwise,  return its  index, or  position, in  TEXTA,
C     counting from the first character stored in TEXTA(*).   The
C     result returned is thus always 0, or not less than LOCA.
C     (18-JAN-83)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       KARGET,      KARORD,      KARUC
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             KARORD,      KARUC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CHAR1,       CHARA,       CHARB,       I
C     SETS                II,          J,           LIMITA,      LIMITB
C
      INTEGER             CHAR1,       CHARA,       CHARB,       I
      INTEGER             II,          J,           LENA,        LENB
      INTEGER             LIMITA,      LIMITB,      LOCA,        LOCB
      INTEGER             TEXTA(*),    TEXTB(*)
C
      KARID2 = 0
      IF (LOCA .LE. 0) GO TO 40
      IF (LOCB .LE. 0) GO TO 40
      IF (LENA .LE. 0) GO TO 40
      IF (LENB .LE. 0) GO TO 40
      CALL KARGET (CHARB,TEXTB,LOCB)
      CHAR1 = KARORD(KARUC(CHARB))
      LIMITA = LOCA + LENA - LENB
      LIMITB = LOCB - 1 + LENB
           DO 30 I = LOCA,LIMITA
           CALL KARGET (CHARA,TEXTA,I)
           CHARA = KARORD(KARUC(CHARA))
           CHARB = CHAR1
           II = I + 1
           J = LOCB + 1
           GO TO 20
C
C     DO WHILE (EQUAL AND IN SUBSTRING) -- PUT TEST AT END TO SAVE GOTO
C
   10      CALL KARGET (CHARB,TEXTB,J)
           CALL KARGET (CHARA,TEXTA,II)
           CHARA = KARORD(KARUC(CHARA))
           CHARB = KARORD(KARUC(CHARB))
           II = II + 1
           J = J + 1
   20      IF ((CHARA .EQ. CHARB) .AND. (J .LE. LIMITB)) GO TO 10
C
C     END WHILE
C
           IF (CHARA .NE. CHARB) GO TO 30
           KARID2 = I
           GO TO 40
   30      CONTINUE
   40 RETURN
      END


      INTEGER FUNCTION  KARIDX (TEXTA,LOCA,LENA,TEXTB,LOCB,LENB)
C     (SUBSTRING INDEX)
C     GIVEN TWO PACKED CHARACTER STRINGS DEFINED BY THE ARGUMENTS
C     TEXTA,LOCA,LENA AND TEXTB,LOCB,LENB, SEARCH THE FIRST
C     STRING FOR THE FIRST OCCURRENCE OF THE SECOND STRING. IF
C     ANY OF THE ARGUMENTS LOCA, LENA, LOCB, OR LENB ARE INVALID,
C     OR IF THE SECOND STRING IS NOT FOUND IN THE FIRST, RETURN
C     0. OTHERWISE, RETURN ITS INDEX, OR POSITION, IN TEXTA,
C     COUNTING FROM THE FIRST CHARACTER STORED IN TEXTA(*).
C     THE RESULT RETURNED IS THUS ALWAYS 0, OR NOT LESS THAN LOCA.
C     (15-DEC-79)
      INTEGER          CHAR1,       CHARA,       CHARB,       I
      INTEGER          II,          J,           KARORD,      LENA
      INTEGER          LENB,        LIMITA,      LIMITB,      LOCA
      INTEGER          LOCB,        TEXTA(*),    TEXTB(*)
      KARIDX = 0
      IF (LOCA .LE. 0) GO TO 40
      IF (LOCB .LE. 0) GO TO 40
      IF (LENA .LE. 0) GO TO 40
      IF (LENB .LE. 0) GO TO 40
      CALL KARGET (CHARB,TEXTB,LOCB)
      CHAR1 = KARORD(CHARB)
      LIMITA = LOCA + LENA - LENB
      LIMITB = LOCB - 1 + LENB
           DO 30 I = LOCA,LIMITA
           CALL KARGET (CHARA,TEXTA,I)
           CHARA = KARORD(CHARA)
           CHARB = CHAR1
           II = I + 1
           J = LOCB + 1
           GO TO 20
C
C     DO WHILE (EQUAL AND IN SUBSTRING) -- PUT TEST AT END TO SAVE GOTO
C
   10      CALL KARGET (CHARB,TEXTB,J)
           CALL KARGET (CHARA,TEXTA,II)
           CHARA = KARORD(CHARA)
           CHARB = KARORD(CHARB)
           II = II + 1
           J = J + 1
   20      IF ((CHARA .EQ. CHARB) .AND. (J .LE. LIMITB)) GO TO 10
C
C     END WHILE
C
           IF (CHARA .NE. CHARB) GO TO 30
           KARIDX = I
           GO TO 40
   30      CONTINUE
   40 RETURN
      END


      INTEGER FUNCTION  KARLC (CH)
      INTEGER UNSPEC,BYTE,CH

#ifdef BIGENDIAN
      DATA UNSPEC /Z'00202020'/
      BYTE = AND(RSHIFT(CH,24),255)
      IF ((BYTE .GE. 65) .AND. (BYTE .LE. 90)) BYTE = BYTE + 32
      KARLC = OR(UNSPEC,LSHIFT(BYTE,24))
#else
      DATA UNSPEC /Z'20202000'/
      BYTE = AND(CH,255)
      IF ((BYTE .GE. 65) .AND. (BYTE .LE. 90)) BYTE = BYTE + 32
      KARLC = OR(UNSPEC,BYTE)
#endif

      RETURN
      END


      INTEGER FUNCTION  KARLCL (ASCORD)
C     (LOCAL HOLLERITH CHARACTER)
C     RETURN THE HOLLERITH CHARACTER IN THE LOCAL CHARACTER SET
C     WHICH CORRESPONDS TO THE ASCII CHARACTER HAVING ORDINAL
C     VALUE "ASCORD".  ONLY THE LOW-ORDER 7 BITS OF "ASCORD" ARE USED
C     TO DETERMINE AN INDEX INTO THE LOCAL CHARACTER TABLE.
C     (17-DEC-79)
      INTEGER          ASCORD,      KARCHR
C
C     THE FOLLOWING CODE IS VALID FOR THOSE HOST COMPUTERS WHICH
C     USE THE ASCII CHARACTER SET.
C
      KARLCL = KARCHR(ASCORD)
      RETURN
      END


      SUBROUTINE  KARMOV (TARGET,LOCTAR,SOURCE,LOCSRC,LENGTH)
C     (MOVE CHARACTERS)
C     GIVEN TWO PACKED CHARACTER STRINGS IN SOURCE(*) AND
C     TARGET(*), MOVE "LENGTH" CHARACTERS, BEGINNING AT
C     OFFSETS "LOCSRC" AND "LOCTAR" RESPECTIVELY.  IF ANY
C     OF "LOCSRC", "LOCTAR", OR "LENGTH" ARE LESS THAN 1,
C     NO CHARACTERS ARE MOVED.
C     (01-MAR-80)
      INTEGER          I,           LENGTH,      LOCSRC
      INTEGER          LOCTAR
      CHARACTER*1      SOURCE(*),   TARGET(*)
      IF (LENGTH .LE. 0) GO TO 20
      IF (LOCSRC .LE. 0) GO TO 20
      IF (LOCTAR .LE. 0) GO TO 20
      DO 10 I = 1,LENGTH
   10 TARGET(I-1+LOCTAR) = SOURCE(I-1+LOCSRC)
   20 RETURN
      END


      INTEGER FUNCTION  KARORD (CH)
      INTEGER CH

#ifdef BIGENDIAN
      KARORD = AND(RSHIFT(CH,24),255)
#else
      KARORD = AND(CH,255)
#endif

      RETURN
      END


      SUBROUTINE  KARPAK (TARGET,LOCTAR,SOURCE,LENSRC)
      INTEGER LENSRC,LOCTAR,IT,IS,I
      CHARACTER*1 TARGET(*),SOURCE(LENSRC)
      IF (LENSRC .LE. 0) GO TO 20
      IF (LOCTAR .LE. 0) GO TO 20
      IT = LOCTAR
      IS = 1
           DO 10 I = 1,LENSRC
           TARGET(IT) = SOURCE(IS)
           IS = IS + 4
           IT = IT + 1
   10      CONTINUE
   20 RETURN
      END


      SUBROUTINE  KARPUT (CHAR,STRING,NPOS)
      INTEGER NPOS
      CHARACTER*1 CHAR(4),STRING(NPOS)
      IF (NPOS .GT. 0) STRING(NPOS) = CHAR(1)
      RETURN
      END


      SUBROUTINE  KARSWP (TEXTA,LOCA,TEXTB,LOCB,LENGTH)
C     (SWAP CHARACTERS)
C     GIVEN TWO PACKED CHARACTER STRINGS IN TEXTA(*) AND
C     TEXTB(*), SWAP "LENGTH" CHARACTERS, BEGINNING AT
C     OFFSETS "LOCA" AND "LOCB" RESPECTIVELY.  IF ANY
C     OF "LOCA", "LOCB", OR "LENGTH" IS LESS THAN 1,
C     NO CHARACTERS ARE SWAPPED.
C     (12-DEC-79)
      INTEGER          CHARA,       CHARB,       I,           LENGTH
      INTEGER          LOCA,        LOCB,        TEXTA(*),    TEXTB(*)
      IF (LENGTH .LE. 0) GO TO 20
      IF (LOCB .LE. 0) GO TO 20
      IF (LOCA .LE. 0) GO TO 20
           DO 10 I = 1,LENGTH
           CALL KARGET (CHARA,TEXTA,I-1+LOCA)
           CALL KARGET (CHARB,TEXTB,I-1+LOCB)
           CALL KARPUT (CHARA,TEXTB,I-1+LOCB)
   10      CALL KARPUT (CHARB,TEXTA,I-1+LOCA)
   20 RETURN
      END


      INTEGER FUNCTION  KARUC (CH)
      INTEGER CH,UNSPEC,BYTE

#ifdef BIGENDIAN
      DATA UNSPEC /Z'00202020'/
      BYTE = AND(RSHIFT(CH,24),255)
      IF ((BYTE .GE. 97) .AND. (BYTE .LE. 122)) BYTE = BYTE - 32
      KARUC = OR(UNSPEC,LSHIFT(BYTE,24))
#else
      DATA UNSPEC /Z'20202000'/
      BYTE = AND(CH,255)
      IF ((BYTE .GE. 97) .AND. (BYTE .LE. 122)) BYTE = BYTE - 32
      KARUC = OR(UNSPEC,BYTE)
#endif

      RETURN
      END


      SUBROUTINE KARUPK (TARGET,SOURCE,LOCSRC,LENGTH)
      INTEGER I,J,LOCSRC,LENGTH,UNSPEC,TARGET(*),MASK
      CHARACTER*1 SOURCE(*),BYTE(4)
      EQUIVALENCE (MASK,BYTE)

#ifdef BIGENDIAN
      DATA UNSPEC /Z'00202020'/, MASK /0/
#else
      DATA UNSPEC /Z'20202000'/, MASK /0/
#endif

      IF (LOCSRC .LE. 0) RETURN
      IF (LENGTH .LE. 0) RETURN
      J = 0
      DO 10 I = LOCSRC,LOCSRC-1+LENGTH
      J = J + 1
      BYTE(1) = SOURCE(I)
      TARGET(J) = OR(UNSPEC,MASK)
   10 CONTINUE
      RETURN
      END


      INTEGER FUNCTION  KARVFY (TEXT,LOCTXT,LENTXT,PATERN,LOCPAT,LENPAT)
C     (VERIFY CHARACTERS)
C     SEARCH THE STRING DEFINED BY TEXT,LOCTXT,LENTXT FOR THE
C     FIRST CHARACTER WHICH IS NOT CONTAINED IN THE PATTERN
C     STRING DEFINED BY PATERN,LOCPAT,LENPAT.  IF ANY OF LOCTXT,
C     LENTXT, LOCPAT, OR LENPAT IS LESS THAN 1, RETURN 0.  IF ALL
C     CHARACTERS IN THE FIRST STRING ARE FOUND IN PATERN(*),
C     RETURN 0.  OTHERWISE RETURN THE INDEX OF THE FIRST
C     MISMATCHING CHARACTER IN TEXT(*), COUNTING FROM THE FIRST
C     CHARACTER STORED IN TEXT(*).  THUS KARVFY ALWAYS RETURNS A
C     VALUE 0, OR ONE WHICH IS NOT LESS THAN LOCTXT.  IT IS
C     IMPORTANT TO NOTE THAT THE INDEX RETURNED POINTS TO THE
C     FIRST STRING, NOT TO THE PATTERN STRING.
C     (12-DEC-79)
      INTEGER          CHAR,        CHPAT,       I,           KARORD
      INTEGER          LENPAT,      LENTXT,      LIMIT,       LOCPAT
      INTEGER          LOCTXT,      MAXINP,      PATERN(*),   TEXT(*)
      LOGICAL          INPAT(256)
      DATA MAXINP/256/
      KARVFY = 0
      IF (LOCTXT .LE. 0) GO TO 40
      IF (LENTXT .LE. 0) GO TO 40
      IF (LOCPAT .LE. 0) GO TO 40
      IF (LENPAT .LE. 0) GO TO 40
C
C     BUILD A LOOKUP TABLE.  THIS NEED ONLY BE AS LARGE AS THE
C     LOCAL CHARACTER SET; THE REMAINDER OF THE CODE IS INDEPENDENT
C     OF THE HOST COMPUTER AND CHARACTER SET.
C
           DO 10 I = 1,MAXINP
   10      INPAT(I) = .FALSE.
           DO 20 I = 1,LENPAT
           CALL KARGET (CHPAT,PATERN,I+LOCPAT-1)
           CHPAT = KARORD(CHPAT)
   20      INPAT(CHPAT+1) = .TRUE.
C
C     NOW CHECK EACH CHARACTER IN TEXT(*) TO SEE IF IT IS IN THE
C     PATTERN.
C
      LIMIT = LOCTXT + LENTXT - 1
           DO 30 I = LOCTXT,LIMIT
           CALL KARGET (CHAR,TEXT,I)
           CHAR = KARORD(CHAR)
           IF (INPAT(CHAR+1)) GO TO 30
           KARVFY = I
           GO TO 40
   30      CONTINUE
   40 RETURN
      END


      SUBROUTINE  KARXLT (TEXT,LOCTXT,LENTXT,OLD,LOCOLD,NEW,LOCNEW,LEN)
C     (TRANSLATE CHARACTERS)
C     GIVEN A PACKED CHARACTER STRING DEFINED BY
C     "TEXT(*),LOCTXT,LENTXT"", TRANSLATE CHARACTERS ACCORDING TO
C     THE REPLACEMENTS IN THE PACKED STRINGS "OLD,LOCOLD,LEN" AND
C     "NEW,LOCNEW,LEN".
C     (12-DEC-79)
      INTEGER          CHAR,        CHNEW,       CHOLD,       I
      INTEGER          KARCHR,      KARORD,      LEN,         LENTXT
      INTEGER          LIMIT,       LOCAL(256),  LOCNEW,      LOCOLD
      INTEGER          LOCTXT,      MAXLOC,      NEW(*),      OLD(*)
      INTEGER          TEXT(*)
      DATA MAXLOC/256/
      IF (LOCTXT .LE. 0) GO TO 40
      IF (LENTXT .LE. 0) GO TO 40
      IF (LOCOLD .LE. 0) GO TO 40
      IF (LOCNEW .LE. 0) GO TO 40
      IF (LEN .LE. 0) GO TO 40
C
C     BUILD A LOOKUP TABLE.  THIS NEED ONLY BE AS LARGE AS THE
C     LOCAL CHARACTER SET; THE REMAINDER OF THE CODE IS INDEPENDENT
C     OF THE HOST COMPUTER AND CHARACTER SET.
C
           DO 10 I = 1,MAXLOC
   10      LOCAL(I) = I-1
           DO 20 I = 1,LEN
           CALL KARGET (CHOLD,OLD,I+1-LOCOLD)
           CALL KARGET (CHNEW,NEW,I+1-LOCNEW)
           CHOLD = KARORD(CHOLD)
           CHNEW = KARORD(CHNEW)
   20      LOCAL(CHOLD+1) = CHNEW
C
C     NOW USE THE LOOKUP TABLE TO REPLACE EACH CHARACTER IN TEXT(*).
C
      LIMIT = LOCTXT + LENTXT - 1
           DO 30 I = LOCTXT,LIMIT
           CALL KARGET (CHAR,TEXT,I)
           CHAR = KARORD(CHAR)
   30      CALL KARPUT (KARCHR(LOCAL(CHAR+1)),TEXT,I)
   40 RETURN
      END
