      SUBROUTINE  ADREAD (INBUF,ADDERR,NWDSIN,MAXIN,INSF)
C     (Adjust Read for INCLUDE)
C     This routine  is  called  when an  "INCLUDE"  directive  is
C     encountered  in  the  input  SFTRAN  file.   This   version
C     supports  a  portable  form  of  INCLUDE  processing.   All
C     members (or elements) which can be copied into a file by an
C     INCLUDE request are stored in a file, ININCL, in the form
C
C     INCLUDE (NAME1)
C     ....0 or more lines....
C     END INCLUDE
C     INCLUDE (NAME2)
C     ....0 or more lines....
C     END INCLUDE
C     ....
C     INCLUDE (NAMEK)
C     ....0 or more lines....
C     END INCLUDE
C     END FILE                      <-- optional
C
C     The INCLUDE directive begins in column 1, and takes one of
C     the forms
C
C     INCLUDE (NAME)
C
C     INCLUDE,L (NAME)
C
C     If the  ",L"  option  is specified,  the  contents  of  the
C     included file will  be printed in  the structured  listing.
C     Note  that  nesting  of  INCLUDES  is  not  permitted,  but
C     otherwise any  text  (SFTRAN,  FORTRAN, or  other)  may  be
C     present.  The  parenthesized  names may  contain  any  text
C     whatever,  including  parentheses,   providing  these   are
C     balanced.  An  exact  match  with  the  parenthesized  name
C     "(NAME)" on the  "INCLUDE" directive  must be  found for  a
C     member  to  be  copied.   The  INCLUDE  file  is   searched
C     circularly for  a  requested  member,  and  ADDERR  is  set
C     according to the following cases:
C
C     ADDERR         CONDITION
C     ======         =========
C        0           successful search.
C        1           INCLUDE name is empty (i.e. INCLUDE (  ) )
C        2           INCLUDE file is unknown (i.e. ININCL .LE. 0)
C        3           INCLUDE element is unknown (i.e. member not found)
C        4           INCLUDE statement has format error
C
C     (04-AUG-80)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3,      F4CLC,       INDEXP,      READLN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3,      INDEXP
      LOGICAL             F4CLC
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                ADDERR,      EMPTY,       EOFINC,      FNDNAM
C     SETS                INSF,        K1,          K2,          K3
C     SETS                LEN1,        LEVEL,       MSTART,      NEXTCH
C     SETS                NREWND,      NTIME,       SFLIST
C
      INTEGER             ADDERR,      INBUF(1),    INSF,        K1
      INTEGER             K2,          K3,          LEN1,        LEVEL
      INTEGER             LINE(80),    MAXIN,       MSTART,      NEXTCH
      INTEGER             NREWND,      NTIME,       NWDSIN
      LOGICAL             EMPTY,       EOFINC,      FNDNAM,      SFLIST
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM15  /
C
      INTEGER             ININCL,      INSFSV,      MCOUNT
      COMMON / COM15  /   ININCL,      INSFSV,      MCOUNT
C
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 IF (.NOT.(ADDERR .EQ. 0)) GO TO 20002
      ASSIGN 20002 TO NPR002
      GO TO 30002
20002 CONTINUE
20003 IF (.NOT.((ADDERR .EQ. 0) .AND. .NOT.FNDNAM)) GO TO 20004
      CALL READLN (ININCL,EOFINC,LINE,NWDSIN)
      EOFINC = EOFINC .OR. F4CLC (8HEND FILE,1,LINE,1,8)
      IF (.NOT.(EOFINC)) GO TO 20005
      ASSIGN 20008 TO NPR003
      GO TO 30003
20008 GO TO 20006
20005 ASSIGN 20009 TO NPR004
      GO TO 30004
20009 CONTINUE
20006 CONTINUE
20007 GO TO 20003
C
20004 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for INCLUDE Directive)
30004 IF (.NOT.(F4CLC(7HINCLUDE,1,LINE,1,7))) GO TO 20010
      MCOUNT = MCOUNT + 1
      ASSIGN 20013 TO NPR005
      GO TO 30005
20013 IF (.NOT.(ADDERR .EQ. 0)) GO TO 20014
      FNDNAM = (INDEXP(LINE,8,MAXIN-7,INBUF,K1,LEN1) .NE. 0)
      IF (.NOT.(FNDNAM)) GO TO 20017
      INSFSV = INSF
      INSF = ININCL
20017 CONTINUE
20018 CONTINUE
20014 CONTINUE
20015 CONTINUE
20010 GO TO 20009
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for Loop because of Missing Member)
30005 IF (.NOT.(MCOUNT .EQ. MSTART)) GO TO 20020
      NTIME = NTIME + 1
      IF (.NOT.(NTIME .GT. 1)) GO TO 20023
      ADDERR = 3
      ASSIGN 20026 TO NPR003
      GO TO 30003
20026 CONTINUE
20023 CONTINUE
20020 GO TO 20013
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check Syntax and Delimit Member Name)
C
C          Verify that the INCLUDE line has one of the forms
C
C          INCLUDE (NAME)
C          INCLUDE,L (NAME)
C
C          The directive  must begin  in column  1, and  may  not
C          contain embedded  blanks  in  the  text  "INCLUDE"  or
C          "INCLUDE,L".   0  or  more  blanks  may  precede   the
C          parenthesized name directive, and  the name field  may
C          contain any characters.   If it contains  parentheses,
C          they must be  balanced.  Text  following the  terminal
C          right parenthesis is ignored.  On a successful return,
C          ADDERR =  0,  K1 is  the  index of  the  opening  left
C          parenthesis,  K2  the  index  of  the  closing   right
C          parenthesis, and LEN1  the length of  the name  field,
C          including  the  parentheses.   On  a  failure  return,
C          ADDERR is 1,  2, 3,  or 4, and  K1, K2,  and LEN1  are
C          undefined.
C
30002 IF (.NOT.(.NOT.F4CLC(7HINCLUDE,1,INBUF,1,7))) GO TO 20027
      ADDERR = 4
      GO TO 31002
20027 SFLIST = F4CLC(INBUF,8,2H,L,1,2)
      IF (.NOT.(SFLIST)) GO TO 20030
      K1 = 10
      GO TO 20031
20030 K1 = 8
20031 NEXTCH = CHGET3 (INBUF,K1)
20033 IF (.NOT.((NEXTCH .EQ. BLNKRZ) .AND. (K1 .LT. MAXIN))) GO TO 20034
      K1 = K1 + 1
      NEXTCH = CHGET3 (INBUF,K1)
      GO TO 20033
20034 IF (.NOT.(K1 .GE. MAXIN)) GO TO 20035
      ADDERR = 1
      GO TO 31002
20035 IF (.NOT.(NEXTCH .NE. LEFTRZ)) GO TO 20038
      ADDERR = 4
      GO TO 31002
C
C         Check for balanced nested parentheses, if any.
C
20038 LEVEL = 1
      K2 = K1
      GO TO 20042
20041 IF ((LEVEL .EQ. 0) .OR. (K2 .GE. MAXIN)) GO TO 20043
20042 K2 = K2 + 1
      NEXTCH = CHGET3 (INBUF,K2)
      IF (.NOT.(NEXTCH .EQ. RITERZ)) GO TO 20044
      LEVEL = LEVEL - 1
      GO TO 20045
20044 IF (.NOT.(NEXTCH .EQ. LEFTRZ)) GO TO 10001
      LEVEL = LEVEL + 1
10001 CONTINUE
20045 GO TO 20041
20043 IF (.NOT.(LEVEL .NE. 0)) GO TO 20047
      ADDERR = 4
      GO TO 31002
C
C         Finally, verify that the name field is not blank.
C
20047 EMPTY = .TRUE.
      K3 =K1+1
      N20050=K2-1
      GO TO 20051
20050 K3 =K3 +1
20051 IF ((N20050-K3 ).LT.0) GO TO 20052
      IF (.NOT.(CHGET3 (INBUF,K3) .NE. BLNKRZ)) GO TO 20054
      EMPTY = .FALSE.
      GO TO 20053
20054 GO TO 20050
20052 CONTINUE
20053 IF (.NOT.(EMPTY)) GO TO 20057
      ADDERR = 1
      GO TO 31002
20057 ADDERR = 0
      LEN1 = K2 - K1 + 1
20058 CONTINUE
31002 GO TO 20002
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize Search)
30001 IF (.NOT.(ININCL .GT. 0)) GO TO 20060
      ADDERR = 0
      GO TO 20061
20060 ADDERR = 2
20061 MSTART = MCOUNT + 1
      NTIME = 0
      FNDNAM = .FALSE.
      NREWND = 0
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Reset INCLUDE File)
30003 REWIND ININCL
      MCOUNT = 0
      NREWND = NREWND + 1
      IF (NREWND .GE. 2) ADDERR = 3
      GO TO NPR003, (20008,20026)
C
      END
